!******************************************************************************
! FILE: ser_mm.f
! DESCRIPTION: 
!   This is the serial version of the matrix multiply example. Fortran version.
!   To make this a parallel processing progam this program would be divided into
!   two parts - the master and the worker section.  The master task would 
!   distributes a matrix multiply  operation to numtasks-1 worker tasks.
!   NOTE1:  C and Fortran versions of this code differ because of the way
!   arrays are stored/passed.  C arrays are row-major order but Fortran
!   arrays are column-major order.
! AUTHOR: unknown
! original:  04/02/05 Blaise Barney 
! revised: 3-12-14 A. Emerson 
!
!******************************************************************************

      program mm

      implicit none
      integer, parameter ::  NRA = 500
      integer, parameter ::  NCA = 500 
      integer, parameter ::  NCB = 500

      integer 	i, j, k
      real*8	a(NRA,NCA), b(NCA,NCB), c(NRA,NCB)


!     Initialize A and B 
      do  i=1, NRA
        do  j=1, NCA
          a(i,j) = (i-1)+(j-1)
        enddo 
      enddo

      do  i=1, NCA
        do  j=1, NCB
	   b(i,j) = (i-1)*(j-1)
        enddo
      enddo 

!     Do matrix multiply
       do  k=1, NCB 
         do  i=1, NRA
           c(i,k) = 0.0
           do  j=1, NCA
              c(i,k) = c(i,k) + a(i,j) * b(j,k)
           enddo 
         enddo
       enddo

!     Print sample results 
      write(*,*) 'C(1,1)', c(1,1) 
      write(*,*) 'C(max,max)',c(nra,ncb) 

      end program mm
